Attribute VB_Name = "GF_WinReg"
Option Explicit

'Modulo realizzato da Gabriele Finessi
'per la gestione dei registri
'di Windows95 e WindowsNT
'Revisione 17/03/97
'Versione in sviluppo



Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" (ByVal hKey As Long, ByVal lpctstr As String, phkey As Long) As Long

Declare Function RegCreateKey Lib "advapi32.dll" Alias "RegCreateKeyA" (ByVal hKey As Long, ByVal lpctstr As String, phkey As Long) As Long

Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, lpData As Any, ByVal cbData As Long) As Long

Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long

Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal hKey As Long, ByVal lpValueName As String) As Long

Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpszValueName As String, ByVal lpdwReserved As Long, lpdwType As Long, lpData As Any, lpcbData As Long) As Long

'Livelli superiori
Public Const HKEY_CLASSES_ROOT = &H80000000
Public Const HKEY_CURRENT_CONFIG = &H80000005
Public Const HKEY_CURRENT_USER = &H80000001
Public Const HKEY_DYN_DATA = &H80000006
Public Const HKEY_LOCAL_MACHINE = &H80000002
Public Const HKEY_PERFORMANCE_DATA = &H80000004
Public Const HKEY_USERS = &H80000003

'Valori di ritorno
Public Const ERROR_SUCCESS = 0&
Public Const ERROR_FILE_NOT_FOUND = 2&
Public Const ERROR_ACCESS_DENIED = 5&
Public Const ERROR_INVALID_HANDLE = 6&
Public Const ERROR_INVALID_PARAMETER = 87
Public Const ERROR_CALL_NOT_IMPLEMENTED = 120&
Public Const ERROR_INSUFFICIENT_BUFFER = 122
Public Const ERROR_MORE_DATA = 234
Public Const ERROR_NO_MORE_ITEMS = 259&
Public Const ERROR_CANTOPEN = 1011&
Public Const ERROR_CANTREAD = 1012&
Public Const ERROR_CANTWRITE = 1013&
Public Const ERROR_REGISTRY_RECOVERED = 1014&
Public Const ERROR_REGISTRY_CORRUPT = 1015&
Public Const ERROR_REGISTRY_IO_FAILED = 1016&
Public Const ERROR_NOT_REGISTRY_FILE = 1017&
Public Const ERROR_KEY_DELETED = 1018&

'Tipi di dati da leggere-salvare nei registri
Public Const REG_NONE = 0
Public Const REG_SZ = 1
Public Const REG_EXPAND_SZ = 2
Public Const REG_BINARY = 3
Public Const REG_DWORD = 4
Public Const REG_DWORD_LITTLE_ENDIAN = 4
Public Const REG_DWORD_BIG_ENDIAN = 5
Public Const REG_LINK = 6
Public Const REG_MULTI_SZ = 7
Public Const REG_RESOURCE_LIST = 8
Public Const REG_FULL_RESOURCE_DESCRIPTOR = 9
Public Const REG_RESOURCE_REQUIREMENTS_LIST = 10


Private Function LPSTR2VBString(ByVal Stringa As String) As String
    'Converte una stringa dal formato LPSTR
    'con terminatore 0 nel formato VisualBasic BSTR
    
    Dim nullpos As Long
    
    nullpos = InStr(Stringa, Chr(0))
    If nullpos > 0 Then
        LPSTR2VBString = Left(Stringa, nullpos - 1)
    Else
        LPSTR2VBString = ""
    End If
    
End Function


Sub RegAddModVariable(ByVal Chiave As String, ByVal Variabile As String, ByVal Valore As String)
'Creazione o modifica di una chiave e relativa variabile

Dim hKey As Long

If RegOpenKey(HKEY_CURRENT_USER, Chiave, hKey) <> ERROR_SUCCESS Then
    Call RegCreateKey(HKEY_CURRENT_USER, Chiave, hKey)
    Call RegSetValueEx(hKey, Variabile, 0&, REG_SZ, ByVal Valore, Len(Valore) + 1)
Else
    Call RegSetValueEx(hKey, Variabile, 0&, REG_SZ, ByVal Valore, Len(Valore) + 1)
End If

Call RegCloseKey(hKey)

End Sub

Sub RegDeleteVariable(ByVal Chiave As String, ByVal Variabile As String)
'Eliminazione di una variabile

Dim hKey As Long

If RegOpenKey(HKEY_CURRENT_USER, Chiave, hKey) = ERROR_SUCCESS Then
    Call RegDeleteValue(hKey, Variabile)
End If

Call RegCloseKey(hKey)

End Sub

Sub RegGetVariable(ByVal Chiave As String, ByVal Variabile As String, ByVal ValDefault As String, Stringa As String, ByVal Dimens As Long)
'Lettura di una variabile

Dim hKey As Long
Dim l As Long

If RegOpenKey(HKEY_CURRENT_USER, Chiave, hKey) <> ERROR_SUCCESS Then
    Stringa = ValDefault
Else
    If RegQueryValueEx(hKey, Variabile, 0, REG_SZ, ByVal Stringa, Dimens) <> ERROR_SUCCESS Then
        Stringa = ValDefault
    End If
End If

Call RegCloseKey(hKey)

If Trim(Stringa) <> "" Then
    Stringa = LPSTR2VBString(Stringa)
End If


End Sub


